Unit AFH2R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, UTAF10_p;

procedure AFH2R(var A :Array of Real; N :Integer; NC :Integer;
                var IERR :Integer);

implementation

procedure AFH2R(var A :Array of Real; N :Integer; NC :Integer;
                var IERR :Integer);
var
NCP1,I,J,K,IMNCP1,I1,L1,I2,JM1,M :Integer;
RN,SUM :Real;
const
ZERO :Real = 0.0E0;
ONE :Real = 1.0E0;
SIXTN :Real = 16.0E0;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10;
begin
IERR := 0;
RN := ONE/((N)*SIXTN);
NCP1 := NC+1;
if ( NC = 0 ) 
 then goto _3;
for I:=1 to NC do
 begin
  for J:=I to NC do
   begin
    K := NCP1-J;
    A[(I-1)+(K-1)*N] := ZERO;
_1:
   end;
_2:
 end;
_3:
for I:=1 to N do
 begin
  IMNCP1 := I-NCP1;
  I1 := Max0(1,1-IMNCP1);
  for J:=I1 to NCP1 do
   begin
    L1 := IMNCP1+J;
    I2 := NCP1-J;
    SUM := A[(I-1)+(J-1)*N];
    JM1 := J-1;
    if ( JM1 ) < 0
     then goto _6
     else if ( JM1 ) > 0
           then goto _4
           else goto _6;
_4:
    for K:=1 to JM1 do
     begin
      M := I2+K;
      SUM := SUM-A[(I-1)+(K-1)*N]*A[(L1-1)+(M-1)*N];
_5:
     end;
_6:
    if ( J <> NCP1 ) 
     then goto _7;
    if ( A[(I-1)+(J-1)*N]+SUM*RN <= A[(I-1)+(J-1)*N] ) 
     then goto _9;
    A[(I-1)+(J-1)*N] := Sqrt(SUM);
    goto _8;
_7:
    A[(I-1)+(J-1)*N] := SUM/A[(L1-1)+(NCP1-1)*N];
_8:
   end;
 end;
goto _10;
_9:
IERR := 65;
UTAF10(IERR,2);
_10:
end;

end.
